// Samoposluga.java - Samoposluga.

package kupovina;

public class Samoposluga {

  private Ulaz[] ulazi;
  private Kasa[] kase;
  private int idBroj = ++ ukBroj, brojKupaca = 0;
  private boolean radi = false;
  private static int ukBroj = 0;

  public Samoposluga (int brojUlaza, int brojKasa, 
                       int maxUlaz, int maxKupovina, int maxNaplata) {
    ulazi  = new Ulaz [brojUlaza];
    for (int i=0; i<brojUlaza; i++)
      ulazi[i] = new Ulaz (this, maxUlaz, maxKupovina);
    kase   = new Kasa [brojKasa];
    for (int i=0; i<brojKasa; i++)
      kase[i] = new Kasa (this, maxNaplata);
    System.out.println ("Samoposluga #" + idBroj + 
      " je spreman za rad");
  }

  public void otvori () {
    radi = true;
    for (int i=0; i<ulazi.length; ulazi[i++].otvori());
    System.out.println ("Samoposluga #" + idBroj + " je otvorena.");
  }

  public void zatvori () {
    radi = false;
    for (int i=0; i<ulazi.length; ulazi[i++].zatvori());
    synchronized (this) {
      while (brojKupaca > 0) 
        try { wait (); } catch (InterruptedException e) {}
    }
    System.out.println ("Samoposluga #" + idBroj + " je zatvorena.");
  }

  public synchronized void usaoKupac   () { brojKupaca++; }

  public synchronized void izasaoKupac () { 
    if (--brojKupaca == 0 && !radi) notify (); 
  }

  public int dohvatiIdBroj () { return idBroj; }

  public Kasa[] dohvatiKase () { return kase; }

  public void unisti () {
    if (radi) zatvori ();
    System.out.println ("Samoposluga #" + idBroj + " se unistava.");
    for (int i=0; i<ulazi.length; ulazi[i++].zavrsi());
    for (int i=0; i<kase .length; kase [i++].zavrsi());
  }

}
