// Ulaz.java - Ulaz u samoposlugu.

package kupovina;

class Ulaz extends Thread {

  private Samoposluga samoposluga;
  private int maxUlaz, maxKupovina, idBroj;
  private boolean gotovo=false, radi=false;
  private static int ukBroj = 0;

  Ulaz (Samoposluga samoposluga, int maxUlaz, int maxKupovina) {
    this.samoposluga = samoposluga;
    this.maxUlaz = maxUlaz;
    this.maxKupovina = maxKupovina;
    idBroj = ++ukBroj;
    start ();
  }

  public void run () {
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " je spreman za rad");
    boolean prvi = true;
    while (true) {
      if (! radi) {
        if (! prvi)
          System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je zatvoren.");
        prvi = false;
        synchronized (this) { 
          while (! radi)
           try { wait (); } catch (InterruptedException e) {} 
        }
        if (! gotovo)
          System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
            samoposluga.dohvatiIdBroj() + " je otvoren.");
      }
    if (gotovo) break;
      try { Thread.sleep ((long) (Math.random() * maxUlaz)); } 
        catch (InterruptedException e) {}
      samoposluga.usaoKupac ();
      Kupac kupac = new Kupac (samoposluga, maxKupovina);
      System.out.println ("Kupac #" + kupac.dohvatiIdBroj() +
        " je usao kroz ulaz #" + idBroj + " samoposluge #" + 
        samoposluga.dohvatiIdBroj());
    }
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " je unisten.");
  }

  synchronized void zatvori () {      // Umesto suspend()
    radi = false;
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " se zatvara.");
  }

  synchronized void otvori () {       // Umesto resume()
    if (! radi) { radi = true; notify (); }
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" +
      samoposluga.dohvatiIdBroj() + " se otvara.");
  }

  synchronized void zavrsi () {       // Umesto stop()
    gotovo = true; 
    if (! radi) { radi = true; notify (); }
    System.out.println ("Ulaz #" + idBroj + " samoposluge #" + 
      samoposluga.dohvatiIdBroj() + " se unistava.");
  }

  int dohvatiIdBroj () { return idBroj; }

}
