// Matrica.java - Klasa za matrice realnih brojeva.

public class Matrica {

  private double[][] mat;

  private static class Mnozac extends Thread {

    private Matrica mat1, mat2;
    private int vrs, kol, duz;
    private double rezultat;
    private static Semafor semafor = new Semafor (5);
  
    Mnozac (Matrica m1, int v, Matrica m2, int k) {
      mat1 = m1; vrs = v; mat2 = m2; kol = k;
      semafor._wait (); start ();
    }

    public void run () {
      for (int j=0; j<mat1.mat[vrs].length; j++)
        rezultat += mat1.mat[vrs][j] * mat2.mat[j][kol];
      semafor._signal ();
    }
  }

  public Matrica (int m, int n) throws Exception {
    mat = new double [m][n];
  }

  public void stavi (int i, int j, double broj) throws Exception {
    if (i<0 || i>mat.length)
      throw new Exception ("\n*** Nedozvoljeni indeks vrste " + 
                           i + " ***\n");
    if (j<0 || j>mat[i].length)
      throw new Exception ("\n*** Nedozvoljeni indeks kolone " +
                           j + " ***\n");
    mat[i][j] = broj;
  }

  public double uzmi (int i, int j) throws Exception {
    if (i<0 || i>mat.length)
      throw new Exception ("\n*** Nedozvoljeni indeks vrste " + 
                           i + " ***\n");
    if (j<0 || j>mat[i].length)
      throw new Exception ("\n*** Nedozvoljeni indeks kolone " +
                           j + " ***\n");
    return mat[i][j];
  }

  public String toString () {
    StringBuffer s = new StringBuffer ();
    for (int i=0; i<mat.length; i++) {
      for (int j=0; j<mat[i].length; j++)
        s.append (mat[i][j]).append (' ');
      s.append ('\n');
    }
    return s.toString ();
  }

  public static Matrica proizvod (Matrica mat1, 
                                  Matrica mat2) throws Exception {
    int l = mat1.mat.length, n = mat2.mat[0].length,
        m1 = mat1.mat[0].length, m2 = mat2.mat.length;
    if (m1 != m2)
      throw new Exception ("\n*** Neusaglasen broj kolona " +
        m1 + " sa brojem vrsta " + m2 + " ***\n");
    Mnozac[][] mno = new Mnozac [l][n];
    for (int i=0; i<l; i++)
      for (int k=0; k<n; k++)
        mno[i][k] = new Mnozac (mat1, i, mat2, k);
    Matrica mat = new Matrica (l,n);
    for (int i=0; i<l; i++) {
      for (int k=0; k<n; k++) {
        try { mno[i][k].join (); } catch (InterruptedException e) {}
        mat.mat[i][k] = mno[i][k].rezultat; mno[i][k] = null;
      }
    }
    return mat;
  }

}

