// RacBroj.java - Klasa racionalnih brojeva (RacBroj).

public class RacBroj {

  static private final int maxProst = 10000;
  static private final long[] prosti = new long [maxProst];

  static {
    int n = 1;
    prosti[0] = 2;
    for (int p=3; n<maxProst; p+=2) {
      boolean prost = true;
      for (int j=0; prosti[j]*prosti[j]<=p; j++)
        if (p % prosti[j] == 0) { prost = false; break; }
      if (prost) prosti[n++] = p;
    }
  }

  private long a, b;

  private void skrati () {
    if (a != 0 && b != 0) {
      for (int i=0; i < maxProst &&
                    prosti[i]*prosti[i]<=a && 
                    prosti[i]*prosti[i]<=b; i++) {
        while (a % prosti[i] == 0 && b % prosti[i] == 0) { 
          a /= prosti[i]; b /= prosti[i]; 
        }
      }
    } else if (a == 0 && b != 0) b = 1;
  }

  public RacBroj () { b = 1; }

  public RacBroj (int a) { this.a = a; b = 1; }

  public RacBroj (int a, int b) { 
    this.a = a; this.b = b; skrati ();
  }

  public RacBroj dodaj (RacBroj x) { 
    a = a * x.b + x.a * b; b *= x.b; 
    skrati (); return this;
  }

  public RacBroj pomnozi (RacBroj x) { 
    a *= x.a; b *= x.b; 
    skrati (); return this;
  }

  public String toString () {
    if (b == 0) return "GRESKA";
    if (a == 0) return "0";
    String rez = a / b != 0 ? Long.toString(a / b) : "";
    if (b != 1) {
      if (rez != "") rez += "+";
      rez += a%b + "/" + b;
    }
    return rez;
  }

}
