// Skladiste2.java - Klasa za uskladistavanje podataka.

public class Skladiste2 {

  private volatile int[] niz;
  private volatile int ulaz, izlaz, pun, redniBroj;

  private static int ukupnoBrojeva = 0;

  public Skladiste2 (int kap) { 
    if ((niz = new int [kap]) == null) System.exit (1);
    redniBroj = ++ukupnoBrojeva;
    System.out.println ("Skladiste #" + redniBroj + " je spreman za rad");
  }

  public synchronized void stavi (int vredn) {
    while (pun == niz.length)
      try { wait (); } catch (InterruptedException e) {}
    niz[ulaz++] = vredn; if (ulaz == niz.length) ulaz = 0;
    pun++;
    notifyAll ();
  }

  public synchronized int uzmi () {
    while (pun == 0)
      try { wait (); } catch (InterruptedException e) {}
    int vredn = niz[izlaz++]; if (izlaz == niz.length) izlaz = 0;
    pun--;
    notifyAll ();
    return vredn;
  }

  public int broj   () { return redniBroj; }

  public int puno   () { return pun; }

  public int prazno () { return niz.length - pun; }

}
