// SortT.java - Klasa prozora aplikacije.

import java.awt.*;
import java.awt.event.*;
import Sortovi.*;

public class SortT extends Frame {

  private int duz = 100;
  private int[] niz = new int [duz];
  private Sort sort = new SortIzbor ();
  private TextArea prikaz = new TextArea ();
  private CheckboxGroup grupa = new CheckboxGroup ();
  
  private void puni () {    // Punjenje niza slucajnim brojevima.
    for (int i=0; i<duz; niz[i++]=(int)(Math.random()*10));
    prikazi ();
  }
  
  private void prikazi () { // Prikazivanje sadrzaja niza.
    int k = (prikaz.getWidth () - 30) / 10;
    String s = "";
    for (int i=0; i<duz; i++)
      s += niz[i] + (i%k==k-1 || i==duz-1 ? "\n" : " ");
    prikaz.setText (s);
  }
  
  private SortT () {        // Sastavljanje prozora (konstruktor).
    super ("Algoritmi za sortiranje");
    setBounds (100, 100, 400, 300);
    addWindowListener (new WindowAdapter () {
      public void windowClosing (WindowEvent d)
        { System.exit(0); }
    } );

    // POPUNJAVANJE PROZORA.
    setLayout (new BorderLayout());

    Panel ploca = new Panel ();
    add (ploca, "East");
    ploca.setLayout (new GridLayout(3,1));
    
    Choice duzina = new Choice ();               // Padajuca lista za
    duzina.addItem ("100");                      //   izbor duzine niza.
    duzina.addItem ("200");
    duzina.addItem ("500");
    duzina.addItem ("1000");
    duzina.addItem ("2000");
    duzina.addItem ("5000");
    duzina.addItemListener (new ItemListener () {
      public void itemStateChanged (ItemEvent d) {
        duz=Integer.parseInt (
          ((Choice)d.getSource()).getSelectedItem());
        niz = new int [duz];puni ();
      }
    } );
    ploca.add (duzina);
                                                 // Radio dugmad za
    RadioPromena osmatrac = new RadioPromena (); //   izbor algoritma.
    Checkbox radio = new Checkbox ("Izbor");
    radio.setCheckboxGroup (grupa);
    radio.addItemListener (osmatrac);
    radio.setState (true);
    ploca.add (radio);
    radio = new Checkbox ("Umetanje");
    radio.setCheckboxGroup (grupa);
    radio.addItemListener (osmatrac);
    ploca.add (radio);

    puni ();               // Viseredni okvir za tekst za prikazivanje
    prikaz.addComponentListener ( new ComponentAdapter() { // niza
      public void componentResized (ComponentEvent d)      // brojeva.
        { prikazi (); }
    } );
    add (prikaz, "Center");
    
    // SASTAVLJANJE MENIJA
    MenuBar traka = new MenuBar ();
    setMenuBar (traka);

    Menu meni = new Menu ("Akcija");
    traka.add (meni);
    MenuItem stavka = new MenuItem ("Pravi", new MenuShortcut ('P'));
    stavka.addActionListener (new ActionListener () {
      public void actionPerformed (ActionEvent d) { puni (); }
    } );
    meni.add (stavka);

    stavka = new MenuItem ("Radi", new MenuShortcut ('R'));
    stavka.addActionListener (new ActionListener () {
      public void actionPerformed (ActionEvent d) 
      { sort.radi (niz, duz); prikazi (); }
    } );
    meni.add (stavka);

    meni.addSeparator();

    stavka = new MenuItem ("Zavrsi", new MenuShortcut ('Z'));
    stavka.addActionListener (
      new ActionListener () {
        public void actionPerformed (ActionEvent d) {
          System.exit (0);
        }
      }
    );
    meni.add (stavka);

    setVisible (true);
  } // Konstruktor
  
  private class RadioPromena implements ItemListener { // Promena radio
    public void itemStateChanged (ItemEvent d) {       //   dugmeta.
      switch (((Checkbox)d.getSource()).getLabel().charAt(0)) {
        case 'I': sort = new SortIzbor (); break;
        case 'U': sort = new SortUmet  (); break;
      }
      sort.radi (niz, duz); prikazi ();
    }
  }
                                                     // Glavni program.
  public static void main (String[] vpar) { new SortT (); }
}